package org.apache.bcel.generic;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import java.io.DataOutputStream;
import java.io.IOException;
import org.apache.bcel.generic.InstructionHandle;
import org.apache.bcel.generic.Select;
import org.apache.bcel.generic.Visitor;
import org.apache.bcel.util.ByteSequence;

public class LOOKUPSWITCH extends Select {
  LOOKUPSWITCH() {}
  
  public LOOKUPSWITCH(int[] match, InstructionHandle[] targets, InstructionHandle defaultTarget) {
    super((short)171, match, targets, defaultTarget);
    short length = (short)(9 + getMatchLength() * 8);
    setLength(length);
    setFixedLength(length);
  }
  
  public void accept(Visitor v) {
    v.visitVariableLengthInstruction(this);
    v.visitStackConsumer(this);
    v.visitBranchInstruction(this);
    v.visitSelect(this);
    v.visitLOOKUPSWITCH(this);
  }
  
  public void dump(DataOutputStream out) throws IOException {
    super.dump(out);
    int matchLength = getMatchLength();
    out.writeInt(matchLength);
    for (int i = 0; i < matchLength; i++) {
      out.writeInt(getMatch(i));
      out.writeInt(setIndices(i, getTargetOffset(getTarget(i))));
    } 
  }
  
  protected void initFromFile(ByteSequence bytes, boolean wide) throws IOException {
    super.initFromFile(bytes, wide);
    int matchLength = bytes.readInt();
    setMatchLength(matchLength);
    short fixedLength = (short)(9 + matchLength * 8);
    setFixedLength(fixedLength);
    short length = (short)(matchLength + getPadding());
    setLength(length);
    setMatches(new int[matchLength]);
    setIndices(new int[matchLength]);
    setTargets(new InstructionHandle[matchLength]);
    for (int i = 0; i < matchLength; i++) {
      setMatch(i, bytes.readInt());
      setIndices(i, bytes.readInt());
    } 
  }
}
